.au "RBK \- style.00" FIRST
.sp 5
.c
C Programming Style
.sp 3
.ce 999
Rob Kolstad, Ph.D.
Sun Microsystems, Inc.
.T kolstad@sun.com
.ce 0

.c
A tip of the hat to Bill Shannon & Warren Tietelman

.c
Copyright \(co 19\n(yr, Kolstad
.bp
.au "RBK \- style.01"

.c
Why Discuss Style?

.2
Software is not read-only

.2
Consistent style can reduce maintenance

.2
Some styles can encourage bug-reducing disciplines

.2
Consistent style can enhance everyone's ability to read, understand, and repair
others' code

.bp
.au "RBK \- style.02"

.c
A ``Perfect'' Style

.2
Style is often religious \- religion is not the focus of this talk

.2
No one style is ``the correct answer''

.2
The key to style at your site is consistency
.3
Which style you choose is not the important issue
.3
Choosing one for your site is the important matter
.bp
.au "RBK \- style.03"

.c
Style Goals

.2
A good style:
.sp 0.5
.3
Is readable \- not obscure
.sp 0.5
.3
Is maintainable \- you can pick code up a year later and still understand
it
.sp 0.5
.3
Is reasonably concise
.sp 0.5
.3
Promotes bug-free code
.sp 0.5
.3
Is appealing

.2
We'll assume that everyone is already sold on ``structured programming''
.bp
.au "RBK \- style.04"

.c
Aspects of Style

.2
Syntax (visual impact of code)
.3
Statements
.3
Blocks
.3
Functions
.3
Files
.3
Mechanical assistance is often available

.2
Semantic \- see ``The Elements of Programming Style'' by Kernighan and
Plauger, McGraw Hill, 2nd Ed., 1978

.2
Idioms \- standard, popular programming snippets that are in widespread use
.bp
.au "RBK \- style.05"

.c
Outline

.2
White Space & Indentation
.2
Statements
.2
Control Statements
.2
Comments
.2
Declarations
.2
Naming
.2
Initialization & Multiple Assignments
.2
File organization
.2
Portability
.2
.T lint
and
.T make
.2
Idioms
.2
Mechanical Indengers
.2
Source control systems
.2
Miscellany
.bp

